Imports PCBI.Automation
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Windows.Forms

Namespace Demo9CSharp
	Public Class Form1
		Inherits Form

		Private components As IContainer = Nothing

		Private WithEvents button1 As Button

		Private mainWindowPCBI As IPCBIWindow

        Protected Sub Dispose(ByVal disposing As Boolean)
            If disposing AndAlso Me.components IsNot Nothing Then
                Me.components.Dispose()
            End If
            MyBase.Dispose(disposing)
        End Sub

        Private Sub InitializeComponent()
            Me.button1 = New Button()
            MyBase.SuspendLayout()
            Me.button1.Location = New Point(12, 12)
            Me.button1.Name = "button1"
            Me.button1.Size = New Size(260, 73)
            Me.button1.TabIndex = 0
            Me.button1.Text = "Demo 9: Create Image from CMPs"
            Me.button1.UseVisualStyleBackColor = True
            MyBase.AutoScaleDimensions = New SizeF(6.0F, 13.0F)
            MyBase.AutoScaleMode = AutoScaleMode.Font
            MyBase.ClientSize = New Size(284, 99)
            MyBase.Controls.Add(Me.button1)
            MyBase.Name = "Form1"
            Me.Text = "Demo 9"
            MyBase.ResumeLayout(False)
        End Sub

        Public Sub New()
            Me.InitializeComponent()
            IAutomation.IAutomationInit()
            Me.mainWindowPCBI = IAutomation.CreateNewPCBIWindow(True)
        End Sub

        Private Sub buttonExportImage_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
           		Dim [step] As IStep = Me.mainWindowPCBI.GetCurrentStep()
            If [step] Is Nothing Then
                MessageBox.Show("Please load a job first to use this demo.", "No Job Loaded!", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
            Else
                Dim layerCMPsTop As ICMPLayer = [step].GetCMPLayer(True)
                If Not layerCMPsTop Is Nothing Then
                    Dim layerObjectList As List(Of IObject) = layerCMPsTop.GetAllLayerObjects()
                    If layerObjectList.Count <> 0 Then
                        For i As Integer = 0 To layerObjectList.Count - 1
                            Try
                                Dim cmp As ICMPObject = CType(layerObjectList(i), ICMPObject)
                                Me.SaveImageFromComponent(cmp, [step], "C:\Tests\Images\")
                            Catch exImg As Exception
                                Console.WriteLine("There was an error " + exImg.ToString())
                            End Try
                        Next
                        Dim errorLog As String = IAutomation.GetErrorLog()
                        If errorLog.Length > 0 Then
                            Debug.WriteLine(errorLog)
                        End If
                    End If
                End If
            End If
        End Sub

        Public Sub SaveImageFromComponent(ByVal CMPforImage As ICMPObject, ByVal [step] As IStep, ByVal FileLocation As String)
            Dim layers As List(Of ILayer) = New List(Of ILayer)()
            Dim CMPlayer As ICMPLayer = [step].GetCMPLayer(CMPforImage.PlacedTop)
            Dim outsideSignalLayer As IODBLayer = [step].GetOutsideODBLayer(CMPforImage.PlacedTop)
            If Not CMPlayer Is Nothing Then
                layers.Add(CMPlayer)
                If outsideSignalLayer IsNot Nothing Then
                    layers.Add(outsideSignalLayer)
                End If
                Dim boundsRelevantCMP As RectangleF = CMPforImage.GetBounds()
                boundsRelevantCMP.Inflate(100.0F, 100.0F)
                Dim imageClass As IStep.BitmapResultClass = [step].GetBitmap(layers, boundsRelevantCMP, 500, 500)
                If imageClass IsNot Nothing Then
                    imageClass.Image.Save(FileLocation + CMPforImage.Ref + ".png", ImageFormat.Png)
                End If
            End If
        End Sub
    End Class
End Namespace
